function [varargout] = gtChangeThreshold3D(firstID, lastID, ~, phaseID, parameters, varargin)
% GTCHANGETHRESHOLD3D
%     seg = gtChangeThreshold3D(firstID, lastID, ~, phaseID, varargin)
%     ----------------------------------------------------------------
%
%     Reads parameters.mat                     : acq.dir, rec
%     Reads 4_grains/phase_##/grain_****.mat   : vol, shift, id
%     Appends 4_grains/phase_##/grain_****.mat : seg, segbb, threshold, Area
%
%     INPUT:
%       varargin = to modify parameters.rec
%

    if (isdeployed)
        global GT_DB
        global GT_MATLAB_HOME
        load('workspaceGlobal.mat');
        firstID = str2double(firstID);
        lastID  = str2double(lastID);
        if (ischar(phaseID))
            phaseID = str2double(phaseID);
        else
            warning('OAR:unexpected_behavior', ...
                'We should expect only strings from shell environment')
        end
    end

    args = [varargin, 'verbose', false];
    thresh = GtThreshold(args{:});
    if (nargin >= 1)
        varargout{1} = thresh.batchThreshold(phaseID, firstID, lastID);
    else
        thresh.batchThreshold(phaseID, firstID, lastID)
    end
end

