function list = gtFindFailedGrains(phase_ID, varargin)
% function list = gtFindFailedGrains(phase_ID, fieldname)
% INPUTS:   phaseid  <int>
%           varargin  {'ODF6D'}  /  'VOL3D' / 'SEG'

if (~isempty(varargin))
    fieldname = varargin{1};
else
    fieldname = 'ODF6D';
end

load(sprintf('4_grains/phase_%02d/index.mat', phase_ID)); 
grain_file_name = sprintf('4_grains/phase_%02d/grain_details_', phase_ID);

if ~exist(fieldname, 'var')
    fieldname = 'ODF6D'
end

num_grains = numel(grain);

list = [];

failed_grains = 0;
for i = 1 : num_grains
    num_chars = fprintf('%d/%d (failed: %d)', i, num_grains, failed_grains);
    mf = matfile(sprintf('%s%04d.mat', grain_file_name, i));
    try 
        size(mf, 'ODF6D');
    catch
        list = [list, i];
        failed_grains = failed_grains + 1;
    end
    fprintf(repmat('\b', [1 num_chars]))
end
end
