function par_rec = gtRecGrainsDefaultParameters(algo)
% FUNCTION par_rec = gtRecGrainsDefaultParameters(algo)
% Arguments can be (default in {}):
%   - algo  : {'SIRT'} | '3DTV' | '6DL1' | '6DTV' | '6DTVL1'
%

    switch (upper(algo))
        case {'SIRT', '3DTV'}
            par_rec = struct(...
                'algorithm', upper(algo), 'num_iter', 10, 'list', [], ...
                'options', []);

        case {'6DL1', '6DTV', '6DTVL1'}
            par_6D_rec_opts = struct( ...
                'grid_edge', 7, 'num_interp', 0, ...
                'lambda', 1e-2, 'volume_downscaling', 1, ...
                'ospace_super_sampling', 1, 'rspace_super_sampling', 1, ...
                'ospace_oversize', 1.1, 'rspace_oversize', 1.2, ...
                'shape_functions_type', 'none', ...
                'detector_norm', 'l2', ... % Possibilities are: {'l2'} | 'KL'
                'tv_norm', 'l12', ... % Possibilities are: {'l12'} | 'l1' | 'ln'
                'tv_strategy', 'groups' ... % Possibilities are: {'groups'} | 'volume'
                );
            par_rec = struct(...
                'algorithm', upper(algo), 'num_iter', 100, 'list', [], ...
                'options',  par_6D_rec_opts);
    end
end
