function s = gtReconstructDataStructureDefinition(type, num_structs)
    switch (upper(type))
        case 'VOL3D'
            s = struct('intensity', [], 'shift', []);
        case 'VOL6D'
            s = struct( ...
                'voxels_avg_R_vectors', [], ...
                'intensity', [], ...
                'shift', [], ...
                'R_vectors', [], ...
                'voxels_stddev_R_vectors', [], ...
                'single_grain_ODF', [], ...
                'single_grain_avg_R_vector', [], ...
                'kernel_average_misorientation', [], ...
                'intra_granular_misorientation', [] );
        otherwise
            error([mfilename ':wrong_argument'], ...
                'Type "%s" not recognized', type)
    end

    if (exist('num_structs', 'var') && ~isempty(num_structs))
        s(2:num_structs) = s;
    end
end
