function gtSigmaTest(boundaries_structure)
%fill in the sigma field of boundaries_structure.mat
%sigmas: type, angle, axis {, brandon criteria}
    sigmas=[3    60    1 1 1;...
            5    36.86 1 0 0;...
            7    38.21 1 1 1;...
            9    38.94 1 1 0;...
            11   50.47 1 1 0;...
            13.1 22.62 1 0 0;...
            13.2 27.79 1 1 1;...
            15   48.19 2 1 0;...
            17.1 28.07 1 0 0;...
            17.2 60.92 2 2 1;...
            19.1 26.53 1 1 0;...
            19.2 46.83 1 1 1;...
            21.1 21.78 1 1 1;...
            21.2 44.41 2 1 1;...
            23   40.45 3 1 1;...
            25.1 16.26 1 0 0;...
            25.2 51.68 3 3 1;...
            27.1 31.59 1 1 0;...
            27.2 35.43 2 1 0;...
            29.1 43.60 1 0 0;...
            29.2 46.40 2 2 1];
    %add brandon criteria
    sigmas(:,6)=15*sigmas(:,1).^(-0.5);
    %normalise axis
    sigmas(:,3:5)=sigmas(:,3:5)./repmat(sqrt(sum(sigmas(:,3:5).*sigmas(:,3:5),2)),1,3);
    warning('sigma axis indices must be positive, normalised, and in descending order...')

    for i=1:length(boundaries_structure)
        if ~isempty(boundaries_structure(i).misorientation_axis)
            mis_axis=sort(abs(boundaries_structure(i).misorientation_axis), 'descend');
            mis_angle=boundaries_structure(i).misorientation_angle;

            %determine sigma type - intially check just sigma three
            test_angle=abs(mis_angle-sigmas(:,2))<sigmas(:,6);
            test_axis=(180/pi)*abs(acos(dot(repmat(mis_axis,size(sigmas,1),1), sigmas(:,3:5), 2)))<sigmas(:,6);
            %if we have a choice, take the lowest sigma value
            boundaries_structure(i).sigma=min(sigmas(find(test_angle & test_axis), 1));
        end
    end

    save('boundaries_structure.mat', 'boundaries_structure')
end % end of function
