function gt6DPlotVolumeSlices(volume, point, varargin)
    conf = struct( ...
        'cmap', jet, ...
        'filename', '', ...
        'clims', [], ...
        'colorbar', 'no');
    conf = parse_pv_pairs(conf, varargin);

    volume = double(volume);
    [size_vol(1), size_vol(2), size_vol(3)] = size(volume);

    f = figure('colormap', conf.cmap);
    ax = axes('parent', f);

    set(f, 'Units', 'centimeters')
    set(ax, 'Units', 'centimeters')

    h = slice(ax, 1:size_vol(2), 1:size_vol(1), 1:size_vol(3), volume, point(2), point(1), point(3));
    set(h, 'EdgeColor','none');

    if (~isempty(conf.clims))
        set(ax, 'CLim', conf.clims)
    end

    if (~strcmpi(conf.colorbar, 'no'))
        set(f, 'Position', [0 0 20 13.5])
        set(f, 'Paperposition', [0 0 20 13.5])

        set(ax, 'Position', [1.25 1 16.5 12])

        cb = colorbar('peer', ax, 'location', 'EastOutside');
        set(cb, 'Units', 'centimeters')
        set(cb, 'Position', [17.35 1 0.65 12])
    else
        set(f, 'Position', [0 0 17 13.5])
        set(f, 'Paperposition', [0 0 17 13.5])

        set(ax, 'Position', [1.25 1 14.5 12])
    end

    slice_ver = [ ...
        1, point(1), point(3); ...
        point(2), 1, point(3); ...
        point(2), point(1), 1; ...
        ...
        size_vol(2), point(1), point(3); ...
        point(2), size_vol(1), point(3); ...
        point(2), point(1), size_vol(3); ...
        ...
        1, 1, point(3); ...
        1, size_vol(1), point(3); ...
        size_vol(2), 1, point(3); ...
        size_vol(2), size_vol(1), point(3); ...
        ...
        1, point(1), 1; ...
        1, point(1), size_vol(3); ...
        size_vol(2), point(1), 1; ...
        size_vol(2), point(1), size_vol(3); ...
        ...
        point(2), 1, 1; ...
        point(2), 1, size_vol(3); ...
        point(2), size_vol(1), 1; ...
        point(2), size_vol(1), size_vol(3); ...
        ];
    faces = [ ...
        1 4; 2 5; 3 6; ... % Intersections
        ];
    patch('parent', ax, 'Faces', faces, 'Vertices', slice_ver, 'FaceColor', 'none', 'EdgeColor', [0 0 0]);
    faces = [ ...
        7 8 10 9; ...
        11 12 14 13; ...
        15 16 18 17; ...
        ];
    patch('parent', ax, 'Faces', faces, 'Vertices', slice_ver, 'FaceColor', 'none', 'EdgeColor', [0 0 0]);
end