function result = gt6DAssembleResult(test_data, sampler, solution)
    gr = sampler.get_orientations();
    num_orient = numel(gr);

    final_vol_size = size(test_data.dmvol(:, :, :, 1));
    num_final_vol_elemes = prod(final_vol_size);

    deviation = cell(num_orient, 1);
    recon_vols = cell(num_orient, 1);

    for ii = 1:num_orient
        ddm = test_data.gv.dm - repmat(gr{ii}.R_vector', [1 num_final_vol_elemes]);
        ddm = sqrt(sum((ddm .^ 2), 1));
        deviation{ii} = reshape(ddm, final_vol_size);

        recon_vols{ii} = max(solution{ii}(:)) - solution{ii};
    end

    result = struct('deviation', {deviation}, 'reconVols', {recon_vols}, ...
        'grains', {gr}, 'solution', {solution});
end