function gtFigureSetSize(f, ax, conf, img_size)
    img_size = img_size * conf.pixel_to_cm;

    set(f, 'Units', 'centimeters')
    if (~conf.borders)
        if (~conf.colorbar)
            figure_position = [0, 0, img_size];
        else
            figure_position = [0, 0, img_size] + [0, 0, 2, 0];
        end
        set(f, 'Position', figure_position)
        set(f, 'Paperposition', figure_position)

        if (conf.colorbar)
            cb = colorbar('peer', ax, 'location', 'EastOutside');
            set(cb, 'Units', 'centimeters')
            position = [img_size(1)+0.35, 0, 0.65, img_size(2)];
            set(cb, 'Position', position)
        end

        set(ax, 'Units', 'centimeters')
        set(ax, 'Position', [0, 0, img_size])
    else
        if (~isempty(conf.label))
            size_padding = 2;
            lower_offset = 1.75;
        else
            size_padding = 1.5;
            lower_offset = 1;
        end

        set(ax, 'Units', 'centimeters')
        if (~conf.colorbar)
            figure_position = [0, 0, img_size] + [0, 0, 2, size_padding];
            set(f, 'Position', figure_position)
            set(f, 'Paperposition', figure_position)
        else
            figure_position = [0, 0, img_size] + [0, 0, 3, size_padding];
            set(f, 'Position', figure_position)
            set(f, 'Paperposition', figure_position)

            cb = colorbar('peer', ax, 'location', 'EastOutside');
            set(cb, 'Units', 'centimeters')
            position = [img_size(1)+1.35, lower_offset, 0.65, img_size(2)];
            set(cb, 'Position', position)
        end
        axes_position = [1, lower_offset, img_size];
        set(ax, 'Position', axes_position)

        if (~isempty(conf.label))
            l = uicontrol('Style', 'Text', 'parent', f, ...
                'String', conf.label, 'FontWeight', 'bold');
            set(l, 'Units', 'centimeters')
            position = [1, 0.25, img_size(1), 0.75];
            set(l, 'Position', position)
        end
    end
    box(ax, 'Off')
    grid(ax, 'Off')
    fprintf('Figure size: [%g, %g] cm\n', figure_position(3:4))
end