function [app_fsim, app_list] = gtAppFsimDefaultPars()
% GTAPPFSIMDEFAULTPARS  Default parameters for gtShowFsim application
%     [app_fsim, app_list] = gtAppFsimDefaultPars()
%
%       clims      = <double>   image color limits {0}
%       conflicts  = <logical>  true if check difspots in conflict {true}
%                               (needs 4_grains/grains_conflicts.mat)
%       fsimtype   = <string>   forward simulation structure name {'allblobs'}|'fwdsim'
%       fsimID     = <double>   number of fsim structure in grain
%                               It is related to the number of geometries
%                               you use and you have stored in the
%                               parameters file if needed {1}
%       replace    = <logical>  true to replace grain.full {true}
%       addspot    = <logical>  add new spots to full image {true}
%       viewblob   = <logical>  view difblob after checking raw images
%                               {false}
%       save_grain = <logical>  update 4_grains/phase_##/grain_####.mat
%                               {false}
%       verbose    = <logical>  true if printing comments {true}
%       resize     = <logical>  resize figure {false}
%       f_title    = <string>   Figure title {''}
%
%     Version 001 30-07-2014 by LNervo

    app_fsim = struct( ...
        'clims', 0, ...
        'conflicts', true, ...
        'replace', true, ...
        'addspot', true, ...
        'viewblob', false, ...
        'save_grain', false, ...
        'verbose', true, ...
        'resize', false, ...
        'f_title', '', ...
        'det_index', 1, ...
        'check', false);

    app_list = get_structure(app_fsim,[],false,[],[]);
    app_list(:,2) = { ...
        'Figure color limits',...
        'Flag to display conflicts if available',...
        'Flag to replace full image when updating',...
        'Flag to add new spots to the image',...
        'Flag to display the blob',...
        'Flag to update the grain_###.mat file',...
        'Flag to display comments on screen',...
        'Flag to resize figure',...
        'Figure title', ...
        'Detector index', ...
        'Flag to check intensity in raw data'};
end
