function labgeo = gtGeoSamEnvFromAcq(labgeo, acq)
% labgeo = gtGeoSamEnv(labgeo, acq)
%
% Calculates the sample envelope using acq.bb and acq.pixelsize, and 
% extends it with 5% but with a minimum of 20 pixels extra. 
%
% Version 002 18-12-2013 by PReischig
%
% Version 001 09-10-2013 by LNervo

% Add margin around bounding box: 5% of total bbox height but min. 20
% pixels more
labgeo.samenvtop = max(acq.bb(4)/2 * 1.05, acq.bb(4)/2 + 20) * acq.pixelsize;
labgeo.samenvbot = -labgeo.samenvtop;
labgeo.samenvrad = max(acq.bb(3)/2 * 1.05, acq.bb(3)/2 + 20) * acq.pixelsize;

end % end of function
