function dd = gtMathsDivergence(d)
% FUNCTION d = gtMathsDivergence(d)
% Computes the divergence of a 1D-2D-3D object.

    if (numel(d) >= 3)
        dz = d{3};
        dd{3} = cat(3, dz(:, :, 1), dz(:, :, 2:end) - dz(:, :, 1:end-1));
    end
    if (numel(d) >= 2)
        dy = d{2};
        dd{2} = cat(2, dy(:, 1, :), dy(:, 2:end, :) - dy(:, 1:end-1, :));
    end
    dx = d{1};
    dd{1} = cat(1, dx(1, :, :), dx(2:end, :, :) - dx(1:end-1, :, :));

    dd = gtMathsSumCellVolumes(dd);
end