function d = gtMathsGradient(x)
% FUNCTION d = gtMathsGradient(vol)
% Computes the gradient of a 1D-2D-3D object and outputs a cell
% concatenation of the directional gradients.

    if (size(x, 3) > 1)
        d{3} = cat(3, x(:, :, 2:end) - x(:, :, 1:end-1), -x(:, :, end));
    end
    if (size(x, 2) > 1)
        d{2} = cat(2, x(:, 2:end, :) - x(:, 1:end-1, :), -x(:, end, :));
    end
    d{1} = cat(1, x(2:end, :, :) - x(1:end-1, :, :), -x(end, :, :));
end