function vol = gtMathsUpsampleVolume(vol, scale)
% FUNCTION vol = gtMathsUpsampleVolume(vol, scale)

    if (iscell(vol))
        for ii = 1:numel(vol)
            vol{ii} = gtMathsUpsampleVolume(vol{ii}, scale);
        end
    else
        vol = upsample_interp_interleaving(vol, scale);
    end
end

function vol = upsample(vol, scale)
% The fastest!
    vol_in_size = size(vol);
    for ii_dim = numel(vol_in_size):-1:1
        indx{ii_dim} = 1:vol_in_size(ii_dim);
        indx{ii_dim} = indx{ii_dim}(ones(scale, 1), :);
        indx{ii_dim} = reshape(indx{ii_dim}, [], 1);
    end
    vol = vol(indx{:});
end

function vol = upsample_interp_interleaving(vol, scale)
% Faster than the custom made, bu still way slower than the simple one
    num_size_4 = size(vol, 4);
    if (num_size_4 == 1)
        vol = interpn(vol, scale-1, 'linear', 0);
    else
        for ii4 = num_size_4:-1:1
            new_vol(:, :, :, ii4) = interp3(vol(:, :, :, ii4), scale-1, 'linear', 0);
        end
        vol = new_vol;
    end
end

function vol = upsample_interp(vol, scale)
% It does exactly what the interleaving does, but it is here as a tutorial
% for future reerence
    vol_in_size = size(vol);
    num_dims = numel(vol_in_size);
    for ii_dim = num_dims:-1:1
        indx_out{ii_dim} = 1:(1/scale):vol_in_size(ii_dim);
    end
    grid_out = cell(1, num_dims);
    [grid_out{:}] = ndgrid(indx_out{:});
    vol = interpn(vol, grid_out{:}, 'linear');
end
